%define kver 2.6.9
%define krelmaj 89
%define krelmin 15
%define krpmver %{krelmaj}.%{krelmin}.AXS2

Summary:       Aarich (Adaptec close source driver)
Name:          kernel-driver-aarich
Version:       6.00.097.I313
Release:       %{kver}_%{krpmver}_1
License:       proprietary
Group:         System Environment/Kernel
URL:           http://www.adaptec.com/
Source:	       aarich-src-6.00.097.I313-1.tgz
Source1:       filter-requires-kernel.sh
Patch0:        aarich-rhlikekernel.patch
Patch1:        aarich-6.00.097.I313-1-writebuffer.patch
Patch2:        aarich-6.00.097.I313-1-aarich2.patch
NoSource:      0

BuildPreReq:   kernel-devel = %{kver}-%{krpmver}
BuildPreReq:   kernel-source = %{kver}-%{krpmver}
Prereq:        kernel-%{_target_cpu} = %{kver}-%{krpmver}

Conflicts:     kernel-driver-aarich2

BuildRoot:     %{_tmppath}/%{name}-%{version}-root
#ExclusiveArch: i686 x86_64 ppc ppc64

%define __perl_requires %{SOURCE1}

%description
This package contains the Aarich kernel module.
Note that this driver does not licensed by the 
OpenSource(TM) term.

%package -n kernel-driver-aarich2
Summary: Aarich (Adaptec close source driver) for up kernel
Group: System Environment/Kernel
Prereq: kernel-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-driver-aarich

%description -n kernel-driver-aarich2
This package contains the Aarich kernel module.
Note that this driver does not licensed by the
OpenSource(TM) term.

%package -n kernel-smp-driver-aarich
Summary: Aarich (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-smp-driver-aarich2

%description -n kernel-smp-driver-aarich
This package contains the Aarich kernel module for smp kernel

%package -n kernel-smp-driver-aarich2
Summary: Aarich (Adaptec close source driver) for smp kernel
Group: System Environment/Kernel
Prereq: kernel-smp-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-smp-driver-aarich

%description -n kernel-smp-driver-aarich2
This package contains the Aarich kernel module for smp kernel

%package -n kernel-hugemem-driver-aarich
Summary: Aarich (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-hugemem-driver-aarich2

%description -n kernel-hugemem-driver-aarich
This package contains the Aarich kernel module for hugemem kernel

%package -n kernel-hugemem-driver-aarich2
Summary: Aarich (Adaptec close source driver) for hugemem kernel
Group: System Environment/Kernel
Prereq: kernel-hugemem-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-hugemem-driver-aarich

%description -n kernel-hugemem-driver-aarich2
This package contains the Aarich kernel module for hugemem kernel

%package -n kernel-largesmp-driver-aarich
Summary: Aarich (Adaptec close source driver) for largesmp kernel
Group: System Environment/Kernel
Prereq: kernel-largesmp-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-largesmp-driver-aarich2

%description -n kernel-largesmp-driver-aarich
This package contains the Aarich kernel module for largesmp kernel

%package -n kernel-largesmp-driver-aarich2
Summary: Aarich (Adaptec close source driver) for largesmp kernel
Group: System Environment/Kernel
Prereq: kernel-largesmp-%{_target_cpu} = %{kver}-%{krpmver}
Conflicts: kernel-largesmp-driver-aarich

%description -n kernel-largesmp-driver-aarich2
This package contains the Aarich kernel module for largesmp kernel


%prep
%setup -q -c aarich
%patch0 -p0
%patch1 -p0
%patch2 -p0

## copy kernel tree for build
/bin/cp -a /usr/src/linux-%{kver}-%{krpmver} .
cd linux-%{kver}-%{krpmver}
## for safe
make clean
ln -s ../../../aarich drivers/scsi/aarich
perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -prep/" Makefile
#perl -p -i -e "s/^NAME.*/NAME = Asianux/" Makefile
cd ..

%build
rm -rf $RPM_BUILD_ROOT
cd linux-%{kver}-%{krpmver}

BuildDriver() {
  make -s mrproper
  KernelVer=%{kver}-%{krpmver}$1
  ModuleDir=$RPM_BUILD_ROOT/lib/modules/$KernelVer/kernel/drivers/scsi
  mkdir -p $ModuleDir
  perl -p -i -e "s/^EXTRAVERSION.*/EXTRAVERSION = -%{krpmver}$1/" Makefile
  if [ -n "$1" ]; then
    cp -a configs/kernel-%{kver}-%{_target_cpu}-$1.config .config
  else
    cp -a configs/kernel-%{kver}-%{_target_cpu}.config .config
  fi
  if [ ! -L include/asm ]; then
    ln -sf asm-%{_arch} include/asm
  fi
  make -s nonint_oldconfig >/dev/null
  make -s include/linux/version.h
  make scripts
  ## normal module
  ln -sf Makefile.k26.aarich drivers/scsi/aarich/Makefile
  make -s SUBDIRS=drivers/scsi/aarich CONFIG_SCSI_AARICH=m modules
  strip -g drivers/scsi/aarich/aarich.ko
  cp -a drivers/scsi/aarich/aarich.ko $ModuleDir
  rm -f drivers/scsi/aarich/*o
  ## ph module
  ln -sf Makefile.k26.aarich.ph drivers/scsi/aarich/Makefile
  make -s SUBDIRS=drivers/scsi/aarich CONFIG_SCSI_AARICH=m modules
  strip -g drivers/scsi/aarich/aarich2.ko
  cp -a drivers/scsi/aarich/aarich2.ko $ModuleDir
  rm -f drivers/scsi/aarich/*o
  make clean
}

# Build driver for each kernels
BuildDriver
BuildDriver smp
%ifarch i686
BuildDriver hugemem
%endif
%ifarch ia64 x86_64
BuildDriver largesmp
%endif

cd ..

%install

%clean
rm -rf ${RPM_BUILD_ROOT}

%post
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0

%post -n kernel-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}
exit 0

%post -n kernel-smp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0

%post -n kernel-smp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}smp
exit 0

%ifarch i686
%post -n kernel-hugemem-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0

%post -n kernel-hugemem-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}hugemem
exit 0

%endif

%ifarch ia64 x86_64
%post -n kernel-largesmp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}largesmp
exit 0

%post -n kernel-largesmp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
[ -x /sbin/new-kernel-pkg ] && /sbin/new-kernel-pkg --mkinitrd --depmod --install %{kver}-%{krpmver}largesmp
exit 0
%endif

%postun
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0

%postun -n kernel-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver} %{kver}-%{krpmver}
exit 0

%postun -n kernel-smp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0

%postun -n kernel-smp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}smp %{kver}-%{krpmver}smp
exit 0

%ifarch i686
%postun -n kernel-hugemem-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0

%postun -n kernel-hugemem-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}hugemem %{kver}-%{krpmver}hugemem
exit 0
%endif

%ifarch ia64 x86_64
%postun -n kernel-largesmp-driver-aarich
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}largesmp %{kver}-%{krpmver}largesmp
exit 0

%postun -n kernel-largesmp-driver-aarich2
[ -x /usr/sbin/module_upgrade ] && /usr/sbin/module_upgrade
depmod -ae -F /boot/System.map-%{kver}-%{krpmver}largesmp %{kver}-%{krpmver}largesmp
exit 0

%endif

%files
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/aarich.ko

%files -n kernel-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}/kernel/drivers/scsi/aarich2.ko

%files -n kernel-smp-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/aarich.ko

%files -n kernel-smp-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}smp/kernel/drivers/scsi/aarich2.ko

%ifarch i686
%files -n kernel-hugemem-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/aarich.ko

%files -n kernel-hugemem-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}hugemem/kernel/drivers/scsi/aarich2.ko
%endif

%ifarch ia64 x86_64
%files -n kernel-largesmp-driver-aarich
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}largesmp/kernel/drivers/scsi/aarich.ko

%files -n kernel-largesmp-driver-aarich2
%defattr(0755,root,root)
/lib/modules/%{kver}-%{krpmver}largesmp/kernel/drivers/scsi/aarich2.ko
%endif

%changelog
* Fri Oct  1 2010 Yoshihiro Takahashi <ytakahashi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.15.AXS2

* Fri Sep 24 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.14.AXS2

* Mon Aug 16 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.13.AXS2

* Mon Jul  5 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.12.AXS2

* Thu May 27 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.11.AXS2

* Wed Apr  7 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.10.AXS2

* Thu Feb 18 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.9.AXS2

* Tue Feb  2 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.8.AXS2

* Tue Jan 19 2010 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.7.AXS2

* Mon Nov  9 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.5AXS2

* Mon Oct 26 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.4AXS2

* Mon Sep 14 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-89.2AXS2

* Fri Jul 17 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.14AXS2

* Thu Jun 25 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.13AXS2

* Tue May 26 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.12AXS2

* Mon Apr 27 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.11AXS2

* Wed Apr  1 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.10AXS2

* Thu Feb  5 2009 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.9AXS2

* Tue Dec 16 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.8AXS2

* Mon Dec 15 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.7AXS2

* Mon Dec  1 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.6AXS2

* Wed Nov 19 2008 Hidehiko MATSUMOTO <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-78.5AXS2

* Tue Nov 17 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-78.4AXS2

* Tue Oct 31 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- Update aarich and aarich2 from 6.00.086 to 6.00.097

* Tue Sep 17 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-42.28AX

* Tue Aug 27 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-42.26AX

* Tue Jul 24 2008 Yoshihiro Kikuchi <ykikuchi@miraclelinux.com>
- rebuild for kernel-2.6.9-42.24AX

* Tue Jul 08 2008 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.23AX

* Tue May 27 2008 Robert Lin <robert@miraclelinux.com>
- rebuild for kernel-2.6.9-42.22AX

* Wed Apr 02 2008 Robert Lin <robert@miraclelinux.com>
- rebuild for kernel-2.6.9-42.21AX

* Tue Mar 11 2008 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.20AX

* Thu Dec 06 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.18AX

* Thu Nov 01 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.17AX

* Thu Sep 27 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.16AX

* Thu Jul 19 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.15AX

* Tue Jun 12 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.14AX

* Wed May 30 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.13AX

* Wed May 02 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.11AX

* Wed Mar 15 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- fixed requirement of aarich2 for up kernel
- rebuild for kernel-2.6.9-42.10AX

* Thu Feb 22 2007 Hidehiko Matsumoto <hmatsumoto@miraclelinux.com>
- rebuild for kernel-2.6.9-42.8AX

* Wed Jan 10 2007 Hiroshi Hara <hhara@miraclelinux.com>
- divide pkg to aarich and aarich2
- rebuild for kernel-2.6.9-42.7AX

* Fri Nov 17 2006 Hiroshi Hara <hhara@miraclelinux.com>
- rebuild for kernel-2.6.9-42.1AX

* Tue Oct 10 2006 Hiroshi Hara <hhara@miraclelinux.com>
- rebuild for kernel-2.6.9-34.28AX

* Wed May 17 2006 Shiro Yamada <shiro@miraclelinux.com> - 2.6.9_34.18AX_6
- rebuild for kernel-2.6.9-34.20AX

* Thu Apr 27 2006 Shiro Yamada <shiro@miraclelinux.com> - 2.6.9_34.17AX_5
- rebuild for kernel-2.6.9-34.17AX

* Thu Apr 13 2006 Shiro Yamada <shiro@miraclelinux.com>
- rebuild for 2.6.9-34.14AX
- deal with PreReq properly

* Tue Mar 28 2006 Shiro Yamada <shiro@miraclelinux.com>
- rebuild for Asianux 2.0 SP1
- add module for kernel-largesmp
- automatically identifies kernel release from kernel-devel package installed

* Mon Nov 28 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Strip -g

* Thu Nov 24 2005 Ryoji Kamei <kamei@miraclelinux.com>
- 6.00.086

* Tue Nov 22 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Diskdump support

* Mon Nov 14 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Fix %post fail

* Tue Nov  1 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change default write buffer flag

* Thu Oct 27 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Change package name scheme to kernel-<tag>-driver-<driver_name>

* Tue Oct 25 2005 Ryoji Kamei <kamei@miraclelinux.com>
- Initial packaging

